
unit PDJComEdit;

// TPDJComEdit version 1.50
// Freeware Component for D3,D,D5,D6
// Copyright  2000-2001 by Peric
// Birthday of Component 25.04.2001.
// E-mail: pericddn@ptt.yu
// If I' find any error or rubbish in TPDJComEdit please send me Your suggest or Reclamation.

{$IFDEF VER100}
  {$DEFINE PDJ_D3}
{$ELSE}
  {$IFDEF VER120}
    {$DEFINE PDJ_D4}
  {$ELSE}
    {$DEFINE PDJ_D5Up}
  {$ENDIF}
{$ENDIF}

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,Buttons,MMsystem;
 {$R PDJCOMEDIT.res}

type
  TButtonGlyphKind = (gkSearch,gkSave,gkFile,gkAdd,gkRemove,gkHome,gkOpen,gkCheck,
   gkEllipsis,gkMail,gkTime,gkDate,gkCustom,gkHelp,gkSilly,gkCancel);
  TButtonLayout = (boGlyphLeft, boGlyphRight);
  TButtonCursor = (cuHandPoint,cuArrow);
  TNumGlyphs = 1..4;
  TPDJComEdit = class(TEdit)
  private
    FButtonGlyphKind:TButtonGlyphKind;
    FButton:TSpeedButton;
    FButtonCursor: TButtonCursor;
    FButtonLayout:TButtonLayout;
    Fsirina:integer;
    FCop: string;
    function GetCop: string;
    procedure SetCop(const Value: string);
    procedure SetButtonGlyphKind(value:TButtonGlyphKind);
    procedure SetButtonLayout(value:TButtonLayout);
    procedure SetButtonCursor(value:TButtonCursor);
    procedure SetFlat(Value: boolean);
    function  GetFlat:boolean;
       {$IFDEF  PDJ_D5Up}
    function  GetBTransparent:boolean;
    procedure SetBTransparent(Value: boolean);
    {$ENDIF}
    function  GetBEnabled:boolean;
    procedure SetBEnabled(Value: boolean);
    procedure SetCaption(const Value: String);
    function  GetCaption:String;
    procedure SetButtonHint(const Value: String);
    function  GetButtonHint:String;
    procedure SetGlyph(const Value: TBitmap);
    function  GetGlyph:TBitmap;
    procedure SetSirina(ASirina:integer);
    function GetNumGlyphs: TNumGlyphs;
    procedure SetNumGlyphs(Value: TNumGlyphs);
    procedure CmEnabledChanged(var Message: TWmNoParams); message CM_ENABLEDCHANGED;
    procedure CmParentColorChanged(var Message: TWMNoParams); message CM_PARENTCOLORCHANGED;
    procedure CmVisibleChanged(var Message: TWmNoParams); message CM_VISIBLECHANGED;
    procedure CmParentFontChanged(var Message: TWMNoParams); message CM_FONTCHANGED;
    function GetOnButtonClick: TNotifyEvent;
    procedure SetOnButtonClick(Value: TNotifyEvent);
  protected
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure CreateWnd;override;
  public
   constructor Create(AOwner: TComponent); override;
   destructor Destroy; override;
  published
   property Version: string read GetCop write SetCop;
   property ButtonGlyphKind:TButtonGlyphKind read FButtonGlyphKind write SetButtonGlyphKind default gkCustom;
   property ButtonLayout:TButtonLayout read FButtonLayout write SetButtonLayout default boGlyphLeft;
   property ButtonFlat:boolean read GetFlat write SetFlat default False;
   property ButtonHint:String
   read GetButtonHint write SetButtonHint;
   property ButtonCursor:TButtonCursor
   read FButtonCursor write SetButtonCursor default cuHandPoint;
   property OnClickButton: TNotifyEvent read GetOnButtonClick write SetOnButtonClick;
   property ButtonGlyph:TBitmap read GetGlyph write SetGlyph;
   property ButtonWidth:integer read FSirina write SetSirina default 20;
   property ButtonNumGlyphs: TNumGlyphs read GetNumGlyphs write SetNumGlyphs default 1;
   property ButtonCaption:String read GetCaption write SetCaption;
      {$IFDEF  PDJ_D5Up}
   property ButtonTransparent:boolean read GetBTransparent write SetBTransparent;
   {$ENDIF}
   property ButtonEnabled:boolean read GetBEnabled write SetBEnabled;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PDJ', [TPDJComEdit]);
end;

constructor TPDJComEdit.Create(AOwner: TComponent);

begin
 inherited Create(AOwner);
  FSirina:=20;
  FCop:='Version 1.50; Copyright  2000-2001 by Peric; E-mail:pericddn@ptt.yu';
  FButtonCursor:= cuArrow;
  FButton := TSpeedButton.Create(Self);
  FButton.Parent:=self;
  FButton.width:=FSirina;
  FButton.top:=top;
  Fbutton.Height :=Height-4;
  Fbutton.Left := Width-FButton.width-4;
  FButton.cursor:=crArrow;
  FButton.ShowHint:=true;
  FButton.Flat:=False;
  FButtonLayout:=boGlyphLeft;
  FButtonGlyphKind:=gkCustom;
end;

    {$IFDEF  PDJ_D5Up}
function TPDJComEdit.GetBTransparent:boolean;
begin
Result:=FButton.Transparent;
end;

procedure TPDJComEdit.SetBTransparent(Value: boolean);
begin
FButton.Transparent:=value;
end;
    {$ENDIF}
function  TPDJComEdit.GetBEnabled:boolean;
begin
Result:=FButton.Enabled;
end;

procedure TPDJComEdit.SetBEnabled(Value: boolean);
begin
FButton.Enabled:=value;
end;


destructor  TPDJComEdit.Destroy;
begin
  FButton.Free;
  inherited Destroy;
end;

function TPDJComEdit.GetCop: string;
begin
Result:=FCop;
end;


procedure TPDJComEdit.SetCop(const Value: string);
begin
FCop:=FCop;
end;


procedure TPDJComEdit.SetButtonGlyphKind(value:TButtonGlyphKind);
begin
  if value <> FButtonGlyphKind then
  begin
    FButtonGlyphKind := value;
    Fbutton.NumGlyphs:=1;

    case FButtonGlyphKind of
    gkSearch:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'lupace');
    gkSave:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'disketace');
    gkFile:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'filece');
    gkAdd:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'plusce');
    gkRemove:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'minusce');
    gkHome:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'homece');
    gkOpen:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'opence');
    gkCheck:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'checkce');
    gkEllipsis:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'elace');
    gkMail:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'mailce');
    gkTime:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'satce');
    gkDate:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'datece');
    gkHelp:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'helpce');
    gkSilly:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'glupce');
    gkCancel:
Fbutton.Glyph.Handle := LoadBitmap(hInstance, 'delce');
end;
end;
end;

procedure TPDJComEdit.SetButtonLayout(Value:TButtonLayout);
begin
  if value <> FButtonLayout then
  begin
    FButtonLayout := value;
    case FButtonLayout of
    boGlyphLeft:
    FButton.Layout:=blGlyphLeft;
    boGlyphRight:
    FButton.Layout:=blGlyphRight;
    end;
  end;
end;

procedure TPDJComEdit.SetButtonCursor(Value:TButtonCursor);
begin
  if value <> FButtonCursor then
  begin
    FButtonCursor := value;
    case FButtonCursor of
    cuHandPoint:
    FButton.cursor:=crHandPoint;
    cuArrow:
    FButton.cursor:=crArrow;
    end;
  end;
end;

function TPDJComEdit.GetOnButtonClick: TNotifyEvent;
begin
  Result := FButton.OnClick;
end;

procedure TPDJComEdit.SetOnButtonClick(Value: TNotifyEvent);
begin
  FButton.onClick := Value;
end;

procedure TPDJComEdit.CmParentFontChanged(var Message: TWMNoParams);
begin
  inherited;
  RecreateWnd;
end;

{procedure TPDJComEdit.TextChanged(sender: TObject);
begin
  inherited;
 // SendMessage(Handle, EM_LIMITTEXT, MaxLength, 0);
  Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FButton.Width+4)*$10000);
end; }

procedure TPDJComEdit.CmParentColorChanged(var Message: TWMNoParams);
begin
  inherited;
  RecreateWnd;
end;

procedure TPDJComEdit.CmVisibleChanged(var Message: TWmNoParams);
begin
  inherited;
end;


procedure TPDJComEdit.CmEnabledChanged(var Message: TWmNoParams);
begin
  inherited;
  FButton.enabled:=enabled;
end;

function TPDJComEdit.GetFlat: boolean;
begin
  Result := FButton.Flat;
end;

procedure TPDJComEdit.SetFlat(Value: boolean);
begin
    FButton.Flat := Value;
end;

function TPDJComEdit.GetNumGlyphs: TNumGlyphs;
begin
  Result := FButton.NumGlyphs;
end;

procedure TPDJComEdit.SetNumGlyphs(Value: TNumGlyphs);
begin
  if Value < 0 then Value := 1
  else if Value > 4 then Value := 4;
  if Value <> FButton.NumGlyphs then
  begin
    FButton.NumGlyphs := Value;
    Invalidate;
  end;
end;

procedure TPDJComEdit.SetGlyph(const Value: TBitmap);
begin

 FButton.Glyph.assign(Value);
 if not FButton.Glyph.Empty then
 begin
 //if  FButton.Glyph.Width = FButton.Glyph.Height then FButton.NumGlyphs :=1;
 if  FButton.Glyph.Width < FButton.Glyph.Height then FButton.NumGlyphs :=1;
  if FButton.Glyph.Width mod FButton.Glyph.Height = 0 then
      begin
        FButton.NumGlyphs := FButton.Glyph.Width div FButton.Glyph.Height;
end;
end;
 if FButton.Glyph.Empty then FButton.NumGlyphs :=1;
 FButtonGlyphKind:=gkCustom;
end;


function TPDJComEdit.GetGlyph: TBitmap;
begin
  result:=FButton.Glyph;
end;

procedure TPDJComEdit.SetButtonHint(const Value: String);
begin
FButton.Hint:=Value;
end;

function  TPDJComEdit.GetButtonHint:String;
begin
result:=Fbutton.Hint;
end;

procedure TPDJComEdit.SetCaption(const Value: String);
begin
FButton.caption:=Value;
end;

function  TPDJComEdit.GetCaption:String;
begin
result:=Fbutton.caption;
end;

procedure TPDJComEdit.SetSirina(ASirina:integer);
begin
FSirina:=ASirina;
FButton.Width:=Fsirina;
RecreateWnd;
end;


procedure TPDJComEdit.WMSize(var Message: TWMSize);
begin
  inherited;
  if Ctl3D then
  begin
  Fbutton.Height :=Height-4;
  Fbutton.Left := Width-FButton.width-4;
  Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FButton.Width+4)*$10000);
  end
  else
  begin
  Fbutton.Height :=Height;
  Fbutton.Left := Width-FButton.width;
  Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FButton.Width+4)*$10000);
  end;

end;

procedure TPDJComEdit.CreateWnd;
begin
  inherited;
 if Ctl3D then
  begin
  Fbutton.Height :=Height-4;
  Fbutton.Left := Width-FButton.width-4;
  Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FButton.Width+4)*$10000);
  end
  else
  begin
  Fbutton.Height :=Height;
  Fbutton.Left := Width-FButton.width;
  Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FButton.Width+4)*$10000);
  end;

end;

end.
